<?php
/**
 * Created by PhpStorm.
 * User: Viktor
 * Date: 01.05.2019
 * Time: 16:29
 */

namespace App\Models;


use InvalidArgumentException;

class User
{
    private $name;
    private $email;
    private $pass;
    private $age;


    private $observers;


    public function save(Db $db) {

        /////......
        if($db->connect('h','h','h','h')) {
            ////........
            $db->query("");

            return true;
        }

        return false;
    }

    public function attach(UserObserver $userObserver) {
        $this->observers[] = $userObserver;
    }

    public function update() {
        $this->notify('update');
    }

    /**
     * User constructor.
     * @param $name
     * @param $email
     * @param $pass
     * @param $age
     */
    public function __construct($name = null, $email = null, $pass = null, $age = null)
    {
        $this->name = $name;
        $this->email = $email;
        $this->pass = $pass;
        $this->age = $age;
    }


    /**
     * @return mixed
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @param mixed $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * @return mixed
     */
    public function getEmail()
    {
        if(empty($this->email)) {
            throw new InvalidArgumentException("message",10);
        }
        return $this->email;
    }

    /**
     * @param mixed $email
     */
    public function setEmail($email)
    {
        $this->email = $email;
    }

    /**
     * @return mixed
     */
    public function getPass()
    {
        return $this->pass;
    }

    /**
     * @param mixed $pass
     */
    public function setPass($pass)
    {
        $this->pass = $pass;
    }

    /**
     * @return mixed
     */
    public function getAge()
    {
        return $this->age;
    }

    /**
     * @param mixed $age
     */
    public function setAge($age)
    {
        $this->age = $age;
    }

    private function notify($string)
    {
        foreach($this->observers as $k => $observer) {
            if($k == 2) {
                $observer->update("www");

            }
            else {
                $observer->update($string);

            }
        }
    }


}